import java.io.*;
import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;

import javax.xml.bind.*;

public class ClientHttp
{
  public final static void main(String[] args)
  {
    HttpClient httpClient = new DefaultHttpClient();
    try
      {
	// ** construction de la requete HTTP
	HttpGet httpGetRequest = new HttpGet("http://localhost:8182/app/xml?id=42");
	HttpResponse httpResponse = httpClient.execute(httpGetRequest);
	// ** recuperation du statut HTTP
	System.out.println("# http status: " + httpResponse.getStatusLine());
	
	HttpEntity entity = httpResponse.getEntity();
	if (entity != null)
	  {
	    // ** parsing du resultat en tant qu'entite XML
	    InputStream inputStream = entity.getContent();
	    JAXBContext jc = JAXBContext.newInstance(HelloObject.class);
	    Unmarshaller u = jc.createUnmarshaller();
	    Object o = u.unmarshal( inputStream );
	    HelloObject h = (HelloObject)o;
	    System.out.println("# hello: id = " + h.id);
	  }
      }
    catch (Exception e)
      {
	e.printStackTrace();
      }
    finally
      {
	httpClient.getConnectionManager().shutdown();
      }
  }
}
